plugins {
    `java-library`
}


repositories {
    mavenCentral()
    maven("https://maven.frohnmeyer-wds.de/artifacts")
}

dependencies {
    val manifoldVersion = "2022.1.27"

    implementation(rootProject)

    implementation("systems.manifold:manifold-ext-rt:$manifoldVersion")

    testAnnotationProcessor(annotationProcessor("systems.manifold:manifold-ext:$manifoldVersion")!!)
}

if (sourceSets.main.get().allJava.files.any {it.name == "module-info.java"}) {
    tasks.withType<JavaCompile> {
        options.compilerArgs.addAll(arrayOf("-Xplugin:Manifold no-bootstrap", "--module-path", classpath.asPath))
    }
} else {
    tasks.withType<JavaCompile> {
        options.compilerArgs.addAll(arrayOf("-Xplugin:Manifold no-bootstrap"))
    }
}
